#ifndef CARTE_H
#define CARTE_H

#include "Case.h"
#include "Position.h"
#include "Fantome.h"
#include "Pacman.h"
#include <string>
using namespace std;

const int LARGEUR_CARTE = 78,  	// Largeur de la carte
          HAUTEUR_CARTE = 21;	// Hauteur de la carte

const int NB_FANTOMES = 4; 	// Le nombre maximum de fantme sur une carte

const int POINTS_BOUFFE = 10; 	// Combien de points vous rapporte le fait de gober
					// une pastille de nourriture
struct Carte
{
   string m_Nom; 					 // Le nom du fichier contenant la carte
   bool m_EstValide; 				 // La carte est-elle valide ?
   Case m_Cases[HAUTEUR_CARTE][LARGEUR_CARTE]; // Un tableau de Case  2 dimensions 
							 // reprsentant la carte
   Pacman m_Pac;					 // Le pacman parcourant la carte
   Fantome m_Fantomes[NB_FANTOMES];		 // Le tableau des fantmes
};

// fonction CreerCarte
// Intrants : Une string contenant le nom du fichier
// Extrants : Une Carte
// Rle : Charger en mmoire le fichier contenant la description complte de la carte
Carte CreerCarte (const string &NomFichier);

// fonction Gerer
// Intrants : Une Carte
// Extrants : Aucun
// Rle : Permet de grer le dplacement des fantmes et dafficher la carte  lcran
void Gerer (Carte &c);

// fonction ObtenirCase
// Intrants : Une Carte et une position dans la carte
// Extrants : Une Case de la carte
// Rle : Permet dobtenir la description dune case de la carte
Case ObtenirCase (const Carte &c, const Position &p);

// fonction VoisineEst   
// Intrants : Une position dans la carte et une Carte
// Extrants : Une position dans la carte
// Rle : Permet la position de la case voisine  lest ( la droite)
Position VoisineEst   (const Position &p, const Carte &c);
 
// fonction VoisineNord  
// Intrants : Une position dans la carte et une Carte
// Extrants : Une position dans la carte
// Rle : Permet la position de la case voisine au nord (en haut)
Position VoisineNord  (const Position &p, const Carte &c);

// fonction VoisineOuest
// Intrants : Une position dans la carte et une Carte
// Extrants : Une position dans la carte
// Rle : Permet la position de la case voisine  louest ( gauche)
Position VoisineOuest (const Position &p, const Carte &c);

// fonction VoisineSud   
// Intrants : Une position dans la carte et une Carte
// Extrants : Une position dans la carte
// Rle : Permet la position de la case voisine au sud (en bas)
Position VoisineSud   (const Position &p, const Carte &c);

// fonction ObtenirPositionPacMan
// Intrants : Une Carte
// Extrants : Une position dans la carte
// Rle : Permet la position du pacman dans la carte
Position ObtenirPositionPacMan (const Carte &c);

// fonction DeplacerPacMan
// Intrants : Une Carte et la nouvelle position du pacman
// Extrants : un boolen indiquant sil a t possible de dplacer le pacman
// Rle : Permet la position du pacman dans la carte
bool DeplacerPacMan (Carte &c, const Position &p);

#endif // !defined CARTE_H
